summaryrefslogtreecommitdiff
path: root/src/testing/test_merchant_instance_auth.sh
diff options
context:
space:
mode:
Diffstat (limited to 'src/testing/test_merchant_instance_auth.sh')
-rwxr-xr-xsrc/testing/test_merchant_instance_auth.sh93
1 files changed, 54 insertions, 39 deletions
diff --git a/src/testing/test_merchant_instance_auth.sh b/src/testing/test_merchant_instance_auth.sh
index 16ab1f09..c85e37e0 100755
--- a/src/testing/test_merchant_instance_auth.sh
+++ b/src/testing/test_merchant_instance_auth.sh
@@ -1,6 +1,6 @@
#!/bin/bash
# This file is part of TALER
-# Copyright (C) 2014-2021 Taler Systems SA
+# Copyright (C) 2014-2023 Taler Systems SA
#
# TALER is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as
@@ -18,15 +18,33 @@
#
# Exit, with status code "skip" (no 'real' failure)
-function exit_skip() {
- echo $1
- exit 77
+function exit_fail() {
+ echo "$@" >&2
+ exit 1
+}
+
+# Cleanup to run whenever we exit
+function my_cleanup()
+{
+ for n in $(jobs -p)
+ do
+ kill $n 2> /dev/null || true
+ done
+ wait
+ if [ ! -z ${LAST_RESPONSE+x} ]
+ then
+ rm -f ${LAST_RESPONSE}
+ fi
}
-. initialize_taler_system.sh
+. setup.sh
+# Launch only the merchant.
+setup -c test_template.conf -m
+CONF="test_template.conf.edited"
+LAST_RESPONSE=`mktemp test_response.conf-XXXXXX`
-echo -n "Configuring 'default' instance ..."
+echo -n "Configuring 'default' instance ..." >&2
STATUS=$(curl -H "Content-Type: application/json" -X POST \
http://localhost:9966/management/instances \
@@ -35,27 +53,26 @@ STATUS=$(curl -H "Content-Type: application/json" -X POST \
if [ "$STATUS" != "204" ]
then
- echo 'should respond ok, instance created. got:' $STATUS
- exit 1
+ exit_fail "Expected 204, instance created. got: $STATUS" >&2
fi
+echo " OK" >&2
-echo " OK"
-
-
-kill $MERCHANT_HTTPD_PID
-wait $MERCHANT_HTTPD_PID
+# Kill merchant
+kill -TERM "$SETUP_PID"
+wait
+unset SETUP_PID
NEW_SECRET=secret-token:different_value
taler-merchant-httpd -a "${NEW_SECRET}" -c "${CONF}" -L DEBUG 2> taler-merchant-httpd.log &
-MERCHANT_HTTPD_PID=$!
-#taler-merchant-httpd -c $CONF -L DEBUG 2> taler-merchant-httpd.log &
+# Install cleanup handler (except for kill -9)
+trap my_cleanup EXIT
-echo -n "Waiting for the merchant..."
+echo -n "Waiting for the merchant..." >&2
# Wait for merchant to be available (usually the slowest)
-for n in `seq 1 50`
+for n in $(seq 1 50)
do
- echo -n "."
+ echo -n "." >&2
sleep 0.1
OK=0
# merchant
@@ -66,40 +83,40 @@ done
if [ "x$OK" != "x1" ]
then
- exit_skip "Failed to start merchant backend"
+ exit_fail "Failed to (re)start merchant backend"
fi
-echo -n "Creating order to test auth is ok..."
+echo -n "Creating order to test auth is ok..." >&2
STATUS=$(curl -H "Content-Type: application/json" -X POST \
'http://localhost:9966/instances/default/private/orders' \
-H 'Authorization: Bearer '$NEW_SECRET \
-d '{"order":{"amount":"TESTKUDOS:1","summary":"payme"}}' \
- -w "%{http_code}" -s -o $LAST_RESPONSE)
+ -w "%{http_code}" -s -o "$LAST_RESPONSE")
if [ "$STATUS" != "200" ]
then
- echo 'should response ok, order created. got:' $STATUS `cat $LAST_RESPONSE`
- exit 1
+ cat "$LAST_RESPONSE" >&2
+ exit_fail "Expected 200, order created. got: $STATUS"
fi
-ORDER_ID=`jq -e -r .order_id < $LAST_RESPONSE`
-TOKEN=`jq -e -r .token < $LAST_RESPONSE`
+ORDER_ID=$(jq -e -r .order_id < "$LAST_RESPONSE")
+TOKEN=$(jq -e -r .token < "$LAST_RESPONSE")
STATUS=$(curl "http://localhost:9966/instances/default/private/orders/${ORDER_ID}" \
-H 'Authorization: Bearer '$NEW_SECRET \
- -w "%{http_code}" -s -o $LAST_RESPONSE)
+ -w "%{http_code}" -s -o "$LAST_RESPONSE")
if [ "$STATUS" != "200" ]
then
- echo 'should response ok, getting order info before claming it. got:' $STATUS `cat $LAST_RESPONSE`
- exit 1
+ cat "$LAST_RESPONSE" >&2
+ exit_fail "Expected 200, getting order info before claming it. got: $STATUS"
fi
-PAY_URL=`jq -e -r .taler_pay_uri < $LAST_RESPONSE`
+PAY_URL=$(jq -e -r .taler_pay_uri < "$LAST_RESPONSE")
-echo OK order $ORDER_ID with $TOKEN
+echo "OK order ${ORDER_ID} with ${TOKEN} and ${PAY_URL}" >&2
-echo -n "Configuring 'second' instance ..."
+echo -n "Configuring 'second' instance ..." >&2
STATUS=$(curl -H "Content-Type: application/json" -X POST \
-H 'Authorization: Bearer '$NEW_SECRET \
@@ -109,13 +126,12 @@ STATUS=$(curl -H "Content-Type: application/json" -X POST \
if [ "$STATUS" != "204" ]
then
- echo 'should respond ok, instance created. got:' $STATUS
- exit 1
+ exit_fail "Expected 204, instance created. got: $STATUS"
fi
-echo "OK"
+echo "OK" >&2
-echo -n "Updating 'second' instance token using the 'default' auth token..."
+echo -n "Updating 'second' instance token using the 'default' auth token..." >&2
STATUS=$(curl -H "Content-Type: application/json" -X POST \
-H 'Authorization: Bearer '$NEW_SECRET \
@@ -125,11 +141,10 @@ STATUS=$(curl -H "Content-Type: application/json" -X POST \
if [ "$STATUS" != "204" ]
then
- echo 'should respond ok, instance auth token changed. got:' $STATUS
- exit 1
+ exit_fail "Expected 204, instance auth token changed. got: $STATUS"
fi
-echo " OK"
-
+echo " OK" >&2
+echo "Test PASSED"
exit 0